package alx;

import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.Produces;

@Path("/")
public class SpisTresci {
    @GET
    @Produces("text/html;charset=UTF-8")
    public String index() {
        return """
                <!DOCTYPE html>
                <html>
                <head>
                <meta charset="UTF-8">
                <title>Elementy techniczne JAX-RS</title>
                </head>
                <body>
                <h1>Elementy techniczne JAX-RS</h1>
                <h2>Podstawy</h2>
                <ul>
                <li><a href="hello">Hello world</a></li>
                <li><a href="student">Student</a> - zwracanie obiektu</li>
                </ul>
            
                <h2>Data i czas</h2>
                <ul>
                <li><a href="dt0">dt0</a> - data i czas jako field</li>
                <li><a href="dt0/date">dt0/date</a></li>
                <li><a href="dt0/time">dt0/time</a></li>
                <li><a href="dt1">dt1</a> - data i czas bezpośrednio</li>
                <li><a href="dt1/date">dt1/date</a></li>
                <li><a href="dt1/time">dt1/time</a></li>
                </ul>
            
                <h2>Parametry</h2>
                <ul>
                <li><a href="parametry/query?a=Ala&b=Ola&b=Ela&t=Basia&t=Kasia&t=Zosia">@QueryParam</a></li>
                <li><a href="parametry/matrix;a=Ala;b=Ola;b=Ela;t=Basia;t=Kasia;t=Zosia">@MatrixParam</a></li>
                <li><a href="parametry/path/Ala/123/98765qwerty@res-zta">@PathParam</a></li>
                <li><a href="parametry/headers">@HeaderParam</a></li>
                <li><a href="parametry/cookies">@CookieParam</a></li>
                <li><a href="parametry/ustaw">Ustaw ciacho</a></li>
                </ul>
            
                <h2>Kalkulator</h2>
                <ul>
                <li><a href="calc/12+13">dodawanie</a></li>
                <li><a href="calc/12*13">mnożenie</a></li>
                </ul>
            
                </body>
                </html>
            """;
    }
}
